Package org.apache.solr.common.cloud

# Enum Class Slice.State

java.lang.Object
java.lang.Enum<Slice.State>
org.apache.solr.common.cloud.Slice.State

All Implemented Interfaces:
  `Serializable`, `Comparable<Slice.State>`, `java.lang.constant.Constable`

Enclosing class:
  `Slice`

public static enum Slice.State extends Enum<Slice.State>
The slice's state.

## Nested Class Summary

## Nested classes/interfaces inherited from class java.lang.Enum

`Enum.EnumDesc<E extends Enum<E>>`

## Enum Constant Summary

Enum Constants
Enum Constant
Description
`ACTIVE`
The normal/default state of a shard.
`CONSTRUCTION`
When a shard is split, the new sub-shards are put in that state while the split operation is in progress.
`INACTIVE`
A shard is put in that state after it has been successfully split.
`RECOVERY`
Sub-shards of a split shard are put in that state, when they need to create replicas in order to meet the collection's replication factor.
`RECOVERY_FAILED`
Sub-shards of a split shard are put in that state when the split is deemed failed by the overseer even though all replicas are active because either the leader node is no longer live or has a different ephemeral owner (zk session id).

## Method Summary

Modifier and Type
Method
Description
`static Slice.State`
`getState(String stateStr)`
Converts the state string to a State instance.
`String`
`toString()`
`static Slice.State`
`valueOf(String name)`
Returns the enum constant of this class with the specified name.
`static Slice.State[]`
`values()`
Returns an array containing the constants of this enum class, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

## Enum Constant Details

### ACTIVE

public static final Slice.State ACTIVE
The normal/default state of a shard.

### INACTIVE

public static final Slice.State INACTIVE
A shard is put in that state after it has been successfully split. See the reference guide for more details.

### CONSTRUCTION

public static final Slice.State CONSTRUCTION
When a shard is split, the new sub-shards are put in that state while the split operation is in progress. It's also used when the shard is undergoing data restoration. A shard in this state still receives update requests from the parent shard leader, however does not participate in distributed search.

### RECOVERY

public static final Slice.State RECOVERY
Sub-shards of a split shard are put in that state, when they need to create replicas in order to meet the collection's replication factor. A shard in that state still receives update requests from the parent shard leader, however does not participate in distributed search.

### RECOVERY_FAILED

public static final Slice.State RECOVERY_FAILED
Sub-shards of a split shard are put in that state when the split is deemed failed by the overseer even though all replicas are active because either the leader node is no longer live or has a different ephemeral owner (zk session id). Such conditions can potentially lead to data loss. See SOLR-9438 for details. A shard in that state will neither receive update requests from the parent shard leader, nor participate in distributed search.

## Method Details

### values

public static Slice.State[] values()
Returns an array containing the constants of this enum class, in the order they are declared.

Returns:
  an array containing the constants of this enum class, in the order they are declared

### valueOf

public static Slice.State valueOf(String name)
Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum class has no constant with the specified name
  `NullPointerException` - if the argument is null

### toString

public String toString()

Overrides:
  `toString` in class `Enum<Slice.State>`

### getState

public static Slice.State getState(String stateStr)
Converts the state string to a State instance.